MULTICALL_ABI = '[{"inputs":[{"components":[{"internalType":"address","name":"target","type":"address"},{"internalType":"bytes","name":"callData","type":"bytes"}],"internalType":"struct Multicall3.Call[]","name":"calls","type":"tuple[]"}],"name":"aggregate","outputs":[{"internalType":"uint256","name":"blockNumber","type":"uint256"},{"internalType":"bytes[]","name":"returnData","type":"bytes[]"}],"stateMutability":"payable","type":"function"},{"inputs":[{"components":[{"internalType":"address","name":"target","type":"address"},{"internalType":"bool","name":"allowFailure","type":"bool"},{"internalType":"bytes","name":"callData","type":"bytes"}],"internalType":"struct Multicall3.Call3[]","name":"calls","type":"tuple[]"}],"name":"aggregate3","outputs":[{"components":[{"internalType":"bool","name":"success","type":"bool"},{"internalType":"bytes","name":"returnData","type":"bytes"}],"internalType":"struct Multicall3.Result[]","name":"returnData","type":"tuple[]"}],"stateMutability":"payable","type":"function"},{"inputs":[{"components":[{"internalType":"address","name":"target","type":"address"},{"internalType":"bool","name":"allowFailure","type":"bool"},{"internalType":"uint256","name":"value","type":"uint256"},{"internalType":"bytes","name":"callData","type":"bytes"}],"internalType":"struct Multicall3.Call3Value[]","name":"calls","type":"tuple[]"}],"name":"aggregate3Value","outputs":[{"components":[{"internalType":"bool","name":"success","type":"bool"},{"internalType":"bytes","name":"returnData","type":"bytes"}],"internalType":"struct Multicall3.Result[]","name":"returnData","type":"tuple[]"}],"stateMutability":"payable","type":"function"},{"inputs":[{"components":[{"internalType":"address","name":"target","type":"address"},{"internalType":"bytes","name":"callData","type":"bytes"}],"internalType":"struct Multicall3.Call[]","name":"calls","type":"tuple[]"}],"name":"blockAndAggregate","outputs":[{"internalType":"uint256","name":"blockNumber","type":"uint256"},{"internalType":"bytes32","name":"blockHash","type":"bytes32"},{"components":[{"internalType":"bool","name":"success","type":"bool"},{"internalType":"bytes","name":"returnData","type":"bytes"}],"internalType":"struct Multicall3.Result[]","name":"returnData","type":"tuple[]"}],"stateMutability":"payable","type":"function"},{"inputs":[],"name":"getBasefee","outputs":[{"internalType":"uint256","name":"basefee","type":"uint256"}],"stateMutability":"view","type":"function"},{"inputs":[{"internalType":"uint256","name":"blockNumber","type":"uint256"}],"name":"getBlockHash","outputs":[{"internalType":"bytes32","name":"blockHash","type":"bytes32"}],"stateMutability":"view","type":"function"},{"inputs":[],"name":"getBlockNumber","outputs":[{"internalType":"uint256","name":"blockNumber","type":"uint256"}],"stateMutability":"view","type":"function"},{"inputs":[],"name":"getChainId","outputs":[{"internalType":"uint256","name":"chainid","type":"uint256"}],"stateMutability":"view","type":"function"},{"inputs":[],"name":"getCurrentBlockCoinbase","outputs":[{"internalType":"address","name":"coinbase","type":"address"}],"stateMutability":"view","type":"function"},{"inputs":[],"name":"getCurrentBlockDifficulty","outputs":[{"internalType":"uint256","name":"difficulty","type":"uint256"}],"stateMutability":"view","type":"function"},{"inputs":[],"name":"getCurrentBlockGasLimit","outputs":[{"internalType":"uint256","name":"gaslimit","type":"uint256"}],"stateMutability":"view","type":"function"},{"inputs":[],"name":"getCurrentBlockTimestamp","outputs":[{"internalType":"uint256","name":"timestamp","type":"uint256"}],"stateMutability":"view","type":"function"},{"inputs":[{"internalType":"address","name":"addr","type":"address"}],"name":"getEthBalance","outputs":[{"internalType":"uint256","name":"balance","type":"uint256"}],"stateMutability":"view","type":"function"},{"inputs":[],"name":"getLastBlockHash","outputs":[{"internalType":"bytes32","name":"blockHash","type":"bytes32"}],"stateMutability":"view","type":"function"},{"inputs":[{"internalType":"bool","name":"requireSuccess","type":"bool"},{"components":[{"internalType":"address","name":"target","type":"address"},{"internalType":"bytes","name":"callData","type":"bytes"}],"internalType":"struct Multicall3.Call[]","name":"calls","type":"tuple[]"}],"name":"tryAggregate","outputs":[{"components":[{"internalType":"bool","name":"success","type":"bool"},{"internalType":"bytes","name":"returnData","type":"bytes"}],"internalType":"struct Multicall3.Result[]","name":"returnData","type":"tuple[]"}],"stateMutability":"payable","type":"function"},{"inputs":[{"internalType":"bool","name":"requireSuccess","type":"bool"},{"components":[{"internalType":"address","name":"target","type":"address"},{"internalType":"bytes","name":"callData","type":"bytes"}],"internalType":"struct Multicall3.Call[]","name":"calls","type":"tuple[]"}],"name":"tryBlockAndAggregate","outputs":[{"internalType":"uint256","name":"blockNumber","type":"uint256"},{"internalType":"bytes32","name":"blockHash","type":"bytes32"},{"components":[{"internalType":"bool","name":"success","type":"bool"},{"internalType":"bytes","name":"returnData","type":"bytes"}],"internalType":"struct Multicall3.Result[]","name":"returnData","type":"tuple[]"}],"stateMutability":"payable","type":"function"}]'

CHAIN_NANE = {
    1: 'mainnet',
    56: 'bsc',
    137: 'polygon',
    250: 'fantom',
    10: 'optimism',
    42161: 'arbitrum',
    8453: 'base',
    43114: 'avalanche',
    1285: 'moonriver',
    1284: 'moonbeam',
    25: 'cronos',
    288: 'boba',
    100: 'gnosis',
    42220: 'celo',
    1088: 'metis',
    2222: 'kava',
    42170: 'arbitrum-nova',
    97: 'bsc-testnet',
    80001: 'mumbai',  # Polygon testnet
    4002: 'fantom-testnet',
    421613: 'arbitrum-goerli',
    43113: 'fuji',  # Avalanche testnet
    3: 'ropsten',
    42: 'kovan',
    4: 'rinkeby',
    5: 'goerli',
}

MULTICALL_ADDRESS = {
    'mainnet': '0xcA11bde05977b3631167028862bE2a173976CA11',
    'bsc': '0xcA11bde05977b3631167028862bE2a173976CA11',
    'polygon': '0xcA11bde05977b3631167028862bE2a173976CA11',
    'fantom': '0xcA11bde05977b3631167028862bE2a173976CA11',
    'optimism': '0xcA11bde05977b3631167028862bE2a173976CA11',
    'arbitrum': '0xcA11bde05977b3631167028862bE2a173976CA11',
    'base': '0xcA11bde05977b3631167028862bE2a173976CA11',
    'avalanche': '0xcA11bde05977b3631167028862bE2a173976CA11',
    'moonriver': '0xcA11bde05977b3631167028862bE2a173976CA11',
    'moonbeam': '0xcA11bde05977b3631167028862bE2a173976CA11',
    'cronos': '0xcA11bde05977b3631167028862bE2a173976CA11',
    'boba': '0xcA11bde05977b3631167028862bE2a173976CA11',
    'gnosis': '0xcA11bde05977b3631167028862bE2a173976CA11',
    'celo': '0xcA11bde05977b3631167028862bE2a173976CA11',
    'metis': '0xcA11bde05977b3631167028862bE2a173976CA11',
    'kava': '0xcA11bde05977b3631167028862bE2a173976CA11',
    'arbitrum-nova': '0xcA11bde05977b3631167028862bE2a173976CA11',
    'bsc-testnet': '0xcA11bde05977b3631167028862bE2a173976CA11',
    'mumbai': '0xcA11bde05977b3631167028862bE2a173976CA11',
    'fantom-testnet': '0xcA11bde05977b3631167028862bE2a173976CA11',
    'arbitrum-goerli': '0xcA11bde05977b3631167028862bE2a173976CA11',
    'fuji': '0xcA11bde05977b3631167028862bE2a173976CA11',
    'ropsten': '0xcA11bde05977b3631167028862bE2a173976CA11',
    'kovan': '0xcA11bde05977b3631167028862bE2a173976CA11',
    'rinkeby': '0xcA11bde05977b3631167028862bE2a173976CA11',
    'goerli': '0xcA11bde05977b3631167028862bE2a173976CA11',
}

DEFAULT_MAKER_DAO_MULTICALL_ADDRESS = '0xcA11bde05977b3631167028862bE2a173976CA11'
